<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html dir="ltr" lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
	<title>Maintaining site navigation with PHP and DOM - EasyNav</title>
	<style type="text/css">
		@import "layout.css";
    </style>
	<script type="text/javascript">
    </script>
</head>
<body>
<div id="content">
<h1>EasyNav - Keeping navigation clean and current</h1>
<ul id="innav">
	<li><a href="#demos">Demos</a></li>
	<li><a href="#demos">Customising</a></li>
	<li><a href="#download">Download</a></li>
	<li><a href="http://www.wait-till-i.com/index.php?p=63">Comment (on the blog)</a></li>
</ul>
<p>EasyNav is a PHP script that allows you to automatically highlight the 
current section in a navigation.</p>
<p><strong>All you need to do is:</strong></p>
<ul>
	<li>Create your navigation as a <a href="demonav.php">plain nested list with links</a>.</li>
	<li>Include the script script in your documents via <br />
	<code><span style="color: #000000">
<span style="color: #007700">&lt;?</span><span style="color: #0000BB">php </span><span style="color: #007700">include(</span><span style="color: #DD0000">'easynav.php'</span><span style="color: #007700">);</span><span style="color: #0000BB">?&gt;</span>
</span>
</code>
	<br />where you want the navigation to appear.</li>
</ul>
<p><strong>EasyNav then does the following:</strong></p>
<ul>
	<li>Loads the navigation template</li>
	<li>Checks the location of the document that it got included into</li>
	<li>Compares each of the links inside the template, and see if they are part of that location</li>
	<li>If that is the case, replaces the link with strong element and sets the proper IDs</li>
</ul>
<p>The IDs set by EasyNav are &#34;active&#34; for the current list item and &#34;current&#34; for the strong element. This allows you to use any CSS of <a href="http://css.maxdesign.com.au/listamatic/" title="Listamatic, lots of examples and tutorials how to style a navigation list">Listamatic</a> to style your navigation.</p>
<p>If your PHP installation has the domxl extension enabled, EasyNav offers even more.</p>
<ul>
	<li>It adds the class &#34;parent&#34; to each list element and its first link containing the current version.</li>
</ul>
<p><strong>Depending on which ID is set</strong> on the root UL of your navigation template:</p>
<ul>
	<li>It removes all the inactive sub sections of the navigation.</li>
	<li>It moves the current section to the top of the navigation.</li>
	<li>It moves the current section below the first item of the navigation.</li>
	<li>Or a mix and match of all of the above.</li>
</ul>
<h2 id="demos">EasyNav Demos</h2>
<ul id="otherlist">
		<li><a href="nav/index.php">Only highlighting the current link and its parent list item.</a></li><li><a href="rsn/index.php">Removing all the inactive sub navigations.</a></li><li><a href="cno/index.php">Making the current section the first.</a></li><li><a href="cnohome/index.php">Making the current section the second after a home link.</a></li><li><a href="rsncno/index.php">Removing all the inactive sub navigations and making the current section the first.</a></li><li><a href="rsncnohome/index.php">Removing all the inactive sub navigations and making the current section the second after a home link.</a></li>
	</ul>

<h2 id="customising">Customising the script</h2>
<p>All the ID names to trigger the different navigation types and the classes and IDs added to the HTML can be changed in the variables section of the script:</p>
<pre>
<code><span style="color: #000000">
<span style="color: #FF8000">/* Variables */<br />// id added to the current LI<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$listitem_id</span><span style="color: #007700">=</span><span style="color: #DD0000">'active'</span><span style="color: #007700">; &nbsp;&nbsp;&nbsp;&nbsp;<br /></span><span style="color: #FF8000">// id added to the current A<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$link_id</span><span style="color: #007700">=</span><span style="color: #DD0000">'current'</span><span style="color: #007700">; &nbsp;&nbsp;&nbsp;&nbsp;<br /></span><span style="color: #FF8000">// navigation file<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$nav</span><span style="color: #007700">=</span><span style="color: #DD0000">'nav.html'</span><span style="color: #007700">;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br /></span><span style="color: #FF8000">/* Variables dependent on DOMXML availability */<br />// class added to each LI containing the current one<br />// and the parent link<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$parentclass</span><span style="color: #007700">=</span><span style="color: #DD0000">'parent'</span><span style="color: #007700">;&nbsp;&nbsp;&nbsp;&nbsp;<br /></span><span style="color: #FF8000">// ID to remove non-active sub navigations<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$rsnID</span><span style="color: #007700">=</span><span style="color: #DD0000">'navrsn'</span><span style="color: #007700">;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br /></span><span style="color: #FF8000">// ID to remove non-active sub navigations and show the <br />// current sub navigation first<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$rsncnoID</span><span style="color: #007700">=</span><span style="color: #DD0000">'navrsncno'</span><span style="color: #007700">;&nbsp;&nbsp;&nbsp;&nbsp; <br /></span><span style="color: #FF8000">// ID to remove non-active sub navigations and show the <br />// current sub navigation<br />// after the home link<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$rsncnonhomeID</span><span style="color: #007700">=</span><span style="color: #DD0000">'navrsncnohome'</span><span style="color: #007700">;<br /></span><span style="color: #FF8000">// ID to show the current sub navigation after the home link<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$cnonhomeID</span><span style="color: #007700">=</span><span style="color: #DD0000">'navcnohome'</span><span style="color: #007700">;<br /></span><span style="color: #FF8000">// ID to show the current sub navigation first<br />&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="color: #0000BB">$cnoID</span><span style="color: #007700">=</span><span style="color: #DD0000">'navcno'</span><span style="color: #007700">;</span></span></code>

</pre>
<h2>Download</h2>
<p>The zip downloadable here contains the script itself, this information page and 
the demos.</p>
<ul>
	<li  id="dl"><a href="easynav.zip">Download EasyNav as a zip file (<?php echo round(filesize('easynav.zip')/1024)?> Kilobytes)</a></li>
</ul>
</div>
<p id="license">
<!-- Creative Commons License -->
<a rel="license" href="http://creativecommons.org/licenses/by-nd-nc/1.0/"><img alt="Creative Commons License" 
src="http://creativecommons.org/images/public/somerights.gif" /></a>
Unless otherwise expressly stated, all original material of whatever nature created by Christian Heilmann and included in this web site and any related pages is licensed under the <a rel="license" href="http://creativecommons.org/licenses/by-nd-nc/1.0/">Creative Commons License</a>.
<!-- /Creative Commons License -->
<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
   <license rdf:resource="http://creativecommons.org/licenses/by-nd-nc/1.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-nd-nc/1.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
</License>
</rdf:RDF>
-->
</p>	
<p id="back2"><a href="http://www.onlinetools.org">More at onlinetools.org</a></p>
</body>
</html>
